﻿Imports System.Collections.Generic
Imports System.Linq
Imports System
Imports Wisej.Web
Imports Wisej.Web.Ext.NavigationBar

Public Class Page1

    Dim treeViewList As List(Of TreeViewItem) = New List(Of TreeViewItem)

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ' level 1
        treeViewList.Add(New TreeViewItem With {
        .ParentId = 0, .Id = 1, .Text = "Parent node", .HasChild = True})

        ' level 2
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 1, .Id = 2, .Text = "First child node", .HasChild = False})
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 1, .Id = 3, .Text = "Second child node", .HasChild = True})

        ' level 3
        treeViewList.Add(New TreeViewItem With {
        .ParentId = 3, .Id = 4, .Text = "3 level of child node - 1", .HasChild = False})
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 3, .Id = 5, .Text = "3 level of child node - 2", .HasChild = True})

        ' level 4
        treeViewList.Add(New TreeViewItem With {
        .ParentId = 5, .Id = 6, .Text = "4 level of child node - 1", .HasChild = False})
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 5, .Id = 7, .Text = "4 level of child node - 2", .HasChild = True})

        ' level 5
        treeViewList.Add(New TreeViewItem With {
        .ParentId = 7, .Id = 8, .Text = "5 level of child node - 1", .HasChild = False})
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 7, .Id = 9, .Text = "5 level of child node - 2", .HasChild = True})

        ' level 6
        treeViewList.Add(New TreeViewItem With {
         .ParentId = 9, .Id = 10, .Text = "6 level of child node - 1", .HasChild = False})
        treeViewList.Add(New TreeViewItem With {
        .ParentId = 9, .Id = 11, .Text = "6 level of child node - 2", .HasChild = False})

        PopulateTreeView(0, Nothing)
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        NavigationBar1.Items.Clear()
        treeViewList.Clear()
    End Sub

    Private Sub NavigationBar1_SelectedItemChanged(sender As Object, e As EventArgs) Handles NavigationBar1.SelectedItemChanged
        Dim itemSelected As NavigationBarItem
        Dim navBar As NavigationBar = CType(sender, NavigationBar)

        itemSelected = navBar.SelectedItem

        If (Not (itemSelected) Is Nothing) Then
            If Not itemSelected.HasChildren Then
                AlertBox.Show(("Menu-Option: " + itemSelected.Text))
            Else
                AlertBox.Show(("Final-Option: " + itemSelected.Text))
            End If

        End If
    End Sub


    Private Sub PopulateTreeView(ByVal parentId As Integer, ByVal parentNode As NavigationBarItem)

        Dim filteredItems = treeViewList.Where(Function(item) _
                                               item.ParentId = parentId)
        Dim childNode As NavigationBarItem

        For Each node As TreeViewItem In filteredItems.ToList
            If (parentNode Is Nothing) Then
                childNode = New NavigationBarItem
                childNode.Text = node.Text
                NavigationBar1.Items.Add(childNode)
                PopulateTreeView(node.Id, childNode)
            Else
                childNode = New NavigationBarItem
                childNode.Text = node.Text
                parentNode.Items.Add(childNode)
                If node.HasChild Then
                    PopulateTreeView(node.Id, childNode)
                Else
                    PopulateTreeView(node.Id, Nothing)
                End If

            End If

        Next
    End Sub


End Class

Public Class TreeViewItem
    Public Id As Integer
    Public ParentId As Integer
    Public Text As String
    Public HasChild As Boolean
End Class
